	ifne	OS-TI92
flib::idle_loop:
	movem.l	a0-a6/d1-d7,-(sp)
        move.w	#2,-(a7)
        jsr	tios::OSTimerRestart
        clr.w	-(a7)
        clr.l	-(a7)
        jsr	tios::GKeyIn
        addq.l	#8,a7
	movem.l	(sp)+,a0-a6/d1-d7
	rts
	endif

; If it is PlusShell / DoorsOS, we need to
; rewrite kernel::exec

 ifeq	OS-TI92
USE_KERNEL	EQU	0
 endif

 ifne	OS-TI92
USE_KERNEL	EQU	1
 endif

 ifeq	USE_KERNEL-1
; Routine by DoorsOS and PlusShell
kernel::exec:
	move.w	4(a7),d0
	tios::DEREF d0,a0
	moveq	#0,d1
	move.w (a0),d1
	lea	1(a0,d1.l),a2
	cmp.b	#$F3,(a2)	;is ASM ?
	bne.s	\Fail
	cmp.l	#"68kP",6(a0)	;is a DoorsOS/Plusshell program ?
	bne.s	\Fail
;	cmp.l	#$200000,a0
;	blt.s	\notarchived
;Temporary unarchive an unarchived prog
;	moveq	#0,d0
;	move.w	(a0),d0
;	addq.l	#3,d0
;	move.l	a0,-(a7)
;	move.l	d0,-(a7)
;	jsr	tios::HeapAlloc	;allocates a block
;	move.l (a7)+,d1
;	move.l (a7)+,a1

;	tst.w	d0
;	beq.s	\Fail

;	move.w	d0,-(a7)	; Save Handle on the stack
;	tios::DEREF	d0,a0
;	move.l	a0,-(a7)
;	subq.l	#1,d1
;\cpy
;	move.b	(a1)+,(a0)+	; We don't need an optimization
;	dbra.s	d1,\cpy
;	move.l (a7)+,a0
;	bra.s	\rel
\notarchived
;	clr.w	-(a7)
\rel
	move.l	a0,a5
	addq.l	#2,a5

	moveq	#0,d1
	move.w	(a0),d1
	lea	1(a0,d1.l),a0

\rloop:	moveq	#0,d0
	move.w -(a0),d0
	beq.s	\endr
	moveq	#0,d1
	move.w	-(a0),d1
	add.l	a5,d1
	move.l	d1,0(a5,d0.l)
	bra.s	\rloop
\endr
	jsr	(a5)	; Go and crash ! (Joke)

;	move.w	(a7)+,d1
;	tst.w	d1	; We don't need to use HeapFree
;	beq.s	\Fail
;	move.l	d0,-(a7)
;	move.w	d1,-(a7)
;	jsr	tios::HeapFree
;	addq.l	#2,a7
;	move.l	(a7)+,d0
\Fail	rts
 endif
