;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***	       THE MISADVENTURES OF B.O.B. IN FERNANDO 3C LAND		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;

; Current release : 0.22

 include "TIOS.h"
; include "Flib.h"
 include "Pk92lib.h"
; include "Hexlib.h"
 include "fer3c.h"

;
;****************************************************************************
;***                                                                      ***
;***            		Choose your O.S.		  	  ***
;***                                                                      ***
;****************************************************************************

; include "FargoII.h"
; include "Plus92.h"
; include "H89.h"
 include "os.h"
 
 include "Bob.h"
 include "EnmBob.h"


; You need it to restore the sprite.
NUMBER		EQU	78	; Nbr of the sprite in Level-File
INIT_ADDON	EQU	114	; Nbr to pass to spriteinit
				; to init an addon. Example :
				; moveq	#INIT_ADDON,d0
				; ...d1 ... d2 ... d3
				; jsr	fer3c::SpriteInit

MAX_SPRITE	EQU	9

; For spriteinit,
; You must test if there are enought space free if you need more than 200 bytes
; Else you can add the sprite without any test.
; a0 -> End of the sprite-buffer
; a1 -> Adress where you will add the sprite
; d0.w = ADD_ON, because it is outside the main program
;	You MUST set the first word of (a1) to d0 : move.w d0,(a1)
; d1.w = X_start
; d2.w = Y_Start
; d3.w = Adress in table
; At the end you must have :
; a1 -> New value of the adress of the end of the sprite-buffer
; Sprite added.
; or else no change of a1.

SpriteInit:
 move.l	LevelADR(a6),a2
 moveq	#0,d4
 move.b 0(a2,d3.w),d4
 move.w	d4,d5
 cmp.w	#MAX_SPRITE,d5
 blt.s	\Ok			; Outside the sprite-table
 rts				; Quit !
\Ok:
 add.w	d5,d5			; Because of table
 clr.b	0(a2,d3.w)		; Clear the graph
 move.w	#4000,YsOld(a6)		; YsOld : Refresh virtual screen
 move.w	Sprite_Init_Code_Table(pc,d5.w),d5
 jmp	Sprite_Init_Code_Table(pc,d5.w)

Sprite_Init_Code_Table
	dc.w	Sprite_Init_Bob-Sprite_Init_Code_Table		; 0
	dc.w	Sprite_Init_L_Head-Sprite_Init_Code_Table	; 1
	dc.w	Sprite_Init_Thief-Sprite_Init_Code_Table	; 2
	dc.w	Sprite_Init_Missile-Sprite_Init_Code_Table	; 3
	dc.w	Sprite_Init_Missile-Sprite_Init_Code_Table	; 4
	dc.w	Sprite_Init_Missile-Sprite_Init_Code_Table	; 5
	dc.w	Sprite_Init_Missile-Sprite_Init_Code_Table	; 6
	dc.w	Sprite_Init_Point-Sprite_Init_Code_Table	; 7
	dc.w	Sprite_Init_Hedg-Sprite_Init_Code_Table		; 8

Sprite_Init_Bob:
 move.l	SpriteADR(a6),a0	; You will change the first sprite number.
 move.w d0,No(a0)		; That is to say Fernando -> Bob.
 clr.w	No2(a0)			; Sub-sprite 0
 move.w	#100,F_Haut(a0)
; Correct the code itself... for key-scan.
; I did it because I think it is easier and faster.
 ifne	CALC_TI92PLUS	; +Shell / Doors
 tst.b	CALCULATOR
 beq.s	\Do89
 moveq	#Left_Key,d0
 move.w	d0,Left0+2
 move.w	d0,Left1+2
 moveq	#Right_Key,d0
 move.w	d0,Right0+2
 move.w	d0,Right1+2
 moveq	#Down_Key,d0
 move.w	d0,Down0+2
 move.w	d0,Down1+2
 move.w	d0,Down2+2
 moveq	#Up_Key,d0
 move.w	d0,Up0+2
 move.w	d0,Up1+2
 moveq	#Jump_Key,d0
 move.w	d0,Jump0+2
 move.w	d0,Jump1+2
 move.w	d0,Jump2+2
 bra.s	\Done
\Do89:
 moveq	#Left_Key_89,d0
 move.w	d0,Left0+2
 move.w	d0,Left1+2
 moveq	#Right_Key_89,d0
 move.w	d0,Right0+2
 move.w	d0,Right1+2
 moveq	#Down_Key_89,d0
 move.w	d0,Down0+2
 move.w	d0,Down1+2
 move.w	d0,Down2+2
 moveq	#Up_Key_89,d0
 move.w	d0,Up0+2
 move.w	d0,Up1+2
 moveq	#Jump_Key_89,d0
 move.w	d0,Jump0+2
 move.w	d0,Jump1+2
 move.w	d0,Jump2+2
\Done:
 endif
 rts			; Exit

Sprite_Init_L_Head:
			; You don't have to test if there are enought space
			; because it needs only 18 bytes
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#2,No2(a1)	; Sub sprite No 1 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 move.w	#LITTLE_HEAD,Dessin(a1)
 move.w	Turbo(a6),L_Vx(a1)	; We will go to the right : SpeedX = Turbo
 move.w	#80,L_Wait(a1)
 lea	L_End(a1),a1	; New SpriteEndADR
 rts			; Exit

Sprite_Init_Thief:
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NOT CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#4,No2(a1)	; Sub sprite No 2 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 move.w	#THIEF,Dessin(a1)
 move.w	Turbo(a6),T_Vx(a1)	; We will go to the right : SpeedX = 1
 move.w	Turbo(a6),T_Vy(a1)
 clr.w	T_Wait(a1)
 lea T_End(a1),a1	; New SpriteEndADR
 rts			; Exit

Sprite_Init_Missile:
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#6,No2(a1)	; Sub sprite No 3 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 lea M_End(a1),a1	; New SpriteEndADR
 rts			; Exit

Sprite_Init_Point:
 move.w	#1,P_Vx(a1)
 move.w	#1,P_Vy(a1)
 bsr.s	Sub_1_Init_Point
 move.w	#1,P_Vx(a1)
 move.w	#-1,P_Vy(a1)
 bsr.s	Sub_1_Init_Point
 move.w	#-1,P_Vx(a1)
 move.w	#1,P_Vy(a1)
 bsr.s	Sub_1_Init_Point
 move.w	#-1,P_Vx(a1)
 move.w	#-1,P_Vy(a1)
; bra.s	Sub_1_Init_Point

Sub_1_Init_Point:
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#8,No2(a1)	; Sub sprite No 4 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 lea P_End(a1),a1	; New SpriteEndADR
 rts

Sprite_Init_Hedg:
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#10,No2(a1)	; Sub sprite No 5 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 move.w	Turbo(a6),H_Vx(a1)	; We will go to the right : SpeedX = 1
 move.w	#20,H_WAct(a1)
 clr.w	H_Act(a1)
 move.w	#30,H_Wait(a1)
 clr.w	H_Fire(a1)
 move.w	#30,H_Invu(a1)
 clr.w	H_A(a1)
 lea	H_End(a1),a1	; New SpriteEndADR
 rts			; Exit







SpriteExec:
 move.w	No2(a5),d0	; Get the type of the sprite
 move.w	Sprite_Code_Table(pc,d0.w),d0     
 jmp	Sprite_Code_Table(pc,d0.w)

Sprite_Code_Table:
	dc.w	Sprite_Bob-Sprite_Code_Table
	dc.w	Sprite_L_Head-Sprite_Code_Table
	dc.w	Sprite_Thief-Sprite_Code_Table
	dc.w	Sprite_Missile-Sprite_Code_Table
	dc.w	Sprite_Point-Sprite_Code_Table
	dc.w	Sprite_Hedg-Sprite_Code_Table

Sprite_Bob:

 move.b fer3c::KeyStat,d4

 move.w Xj(a5),d6
 move.w Yj(a5),d7


 move.w	Turbo(a6),d0
 add.w	d0,d0
 move.w	d0,F_Speed(a5)

 move.w d6,d0
 move.w d7,d1

; Left ?
Left0:
 btst.b #Left_Key,d4
 bne.s  NoLeft

 move.w #1,F_Sens(a5)
 sub.w  F_Speed(a5),d0
 jsr    fer3c::GetTest
 bne.s	\Okg
 move.w	d6,d0
 subq.w	#1,d0
 jsr	fer3c::GetTest
 beq.s	SuiteAct
\Okg:
 move.w d0,d6
 bra.s	SuiteAct

; Right ?
NoLeft: 
Right0:
 btst.b #Right_Key,d4
 bne.s  SuiteAct
 clr.w  F_Sens(a5)
 add.w  F_Speed(a5),d0
 jsr    fer3c::GetTest
 bne.s	\Okd
 move.w	d6,d0
 addq.w	#1,d0
 jsr	fer3c::GetTest
 beq.s	SuiteAct
\Okd:
 move.w d0,d6
SuiteAct:

; Test sortie Gauche/Droite
 cmpi.w #4080,d0	; 32 * tailleX - TaillXBob
 bls.s	\Suitegd0
 clr.w  F_Mx(a5)
 clr.w  d6
 tst.w	d0
 blt.s	\Suitegd0
 move.w #4080,d6
\Suitegd0:

 move.w   F_Action(a5),d0
 move.w   Action_Code_Table(pc,d0.w),d0     
 jsr      Action_Code_Table(pc,d0.w)

 bsr	Limites
 jsr	fer3c::ReadOption
 
 move.w d6,Xj(a5)
 move.w d7,Yj(a5)

 moveq	#0,d2
 move.w	d6,d0
 move.w	d7,d1
 move.w	Dessin(a5),d2
 add.w	F_Sens(a5),d2

 bsr	PutSprite

; Print the shield
 move.w v(a6),d2
 beq.s	\Escape
 subq.w #1,d2
 move.w d2,v(a6)
 moveq	#BULLE,d2
 bsr	PutSprite
\Escape:

; Mise  jour des coordonnes du scrolling
 jsr	fer3c::UpDateScrollVar

; Next Sprite
 lea	F_End(a5),a5
 rts

Action_Code_Table:
	dc.w Tombe-Action_Code_Table		; 0
	dc.w Marche-Action_Code_Table		; 2
	dc.w Saut-Action_Code_Table		; 4
	dc.w Bumper-Action_Code_Table		; 6
	dc.w Propulseur-Action_Code_Table	; 8
	dc.w Special_Saut-Action_Code_Table	; 10
	dc.w Accroche-Action_Code_Table		; 12
	dc.w PasseurAct-Action_Code_Table	; 14
	dc.w Fly-Action_Code_Table		; 16
	dc.w Grimpe-Action_Code_Table		; 18

Special_Saut:
 move.w #SPECIAL_SAUT,Dessin(a5)
 bra.s	SautRoutine

Saut:
 move.w #SAUT,Dessin(a5)
SautRoutine:
 move.w	F_St(a5),d2
 blt.s	Sau2
 and.w	#15,d2
 bne.s	SautEntry
Jump0:
 btst.b	#Jump_Key,d4
 beq.s	SautEntry
 clr.w	F_St(a5)
SautEntry:
 move.w	F_Speed(a5),d2
 sub.w	d2,F_St(a5)
 move.w	d6,d0
 move.w	d7,d1
 sub.w	d2,d1
 jsr	fer3c::GetTest
 beq.s	Sau2
 move.w	d1,d7
SautEnd:
 rts
Sau2:
 clr.w F_Action(a5)
 rts

Tombe:
 move.w d6,d0
 move.w d7,d1
 add.w	F_Speed(a5),d1
 jsr	fer3c::GetTest
 bne.s	\TombeL1
 move.w	d7,d1
 addq.w	#1,d1
 jsr	fer3c::GetTest
 beq.s  Marche
\TombeL1:
 move.w d1,d7
 move.w #TOMBE,Dessin(a5)
 rts

Marche:
Jump1:
 btst.b	#Jump_Key,d4
 bne.s Mar1
 move.w F_Haut(a5),d2
 move.w d2,F_St(a5)
 move.w #4,F_Action(a5)
 bra  SautEntry

Mar1:
 cmpi.b #255,d4
 bne.s  Mar2
 tst.b	F_BWait(a5)
 beq.s  PasseTemps
 addq.b #1,F_BWait(a5)
 move.w #DEBOUT,Dessin(a5)
 rts

Mar2:
 move.b #1,F_BWait(a5)
 move.w #MARCHE,Dessin(a5)
MarcheEntry:
 move.w  F_Phase(a5),d0
 addq.w  #1,d0
 andi.w  #31,d0
 move.w  d0,F_Phase(a5)
 andi.w  #24,d0
 lsr.w   #2,d0
 add.w   d0,Dessin(a5)
 rts

PasseTemps:
 move.w #PASSE_TEMPS,Dessin(a5)
 bra.s	MarcheEntry

Bumper:
 move.w F_St(a5),d2
 blt	Sau2
 move.w #BUMPER,Dessin(a5)
 bsr    MarcheEntry
 bra    SautEntry

Propulseur:
 move.w F_Mx(a5),d0
 bne.s	PropSuite
 tst.w	F_My(a5)
 beq.s	ThatsAll
PropSuite:
 add.w  d6,d0
 move.w d7,d1
 clr.w  F_Sens(a5)
 jsr	fer3c::GetTest
 beq.s	ThatsAll
 move.w d0,d6
 add.w  F_My(a5),d1
 jsr	fer3c::GetTest
 beq.s	ThatsAll
 move.w d1,d7
 rts

ThatsAll:
 clr.l  F_Mx(a5)
 bra    Sau2 

Accroche:
 moveq	#24,d3		; 24 is the test Hooking
 move.w #ACCROCHE,Dessin(a5)
Right1:
 btst.b #Right_Key,d4
 beq.s	Exit0
Left1:
 btst.b #Left_Key,d4
 bne.s	Accroche_Exit1
Exit0:
 bsr    MarcheEntry
Accroche_Exit1:
Jump2:
 btst.b	#Jump_Key,d4
 bne.s	Exit2_Accr
Down2:
 btst.b	#Down_Key,d4
 beq.s	Fall_Accroche	; Usefull ?
 move.w F_Haut(a5),d0
 move.w d0,F_St(a5)
 move.w #4,F_Action(a5)
 rts
Exit2_Accr:
 move.w	d6,d0
 move.w	d7,d1
 bsr	Lecture
 cmp.b	d3,d2			; Test Accroche option (Hook-option)
 beq.s	Ok_Accroche
 add.w	#15,d1
 bsr	Lecture
 cmp.b	d3,d2			; Test Accroche option (Hook-option)
 beq.s	Ok_Accroche
Fall_Accroche:
 clr.w  F_Action(a5)
Ok_Accroche:
 rts

PasseurAct:
 move.w  #PASSEUR,Dessin(a5)

 move.w Time(a6),d1
 lsr.w  #4,d1
 andi.w #31,d1
 and.w  #$FFE0,d7
 cmpi.w #16,d1
 bls.s	\Nothing
 add.w  #32,d7
 neg.w  d1
\Nothing:
 add.w  d1,d7
 bra	Accroche_Exit1

Fly:
; Explosion ?
 move.w  Time(a6),d0
 andi.w  #127,d0
 bne.s	\skip
 moveq #10,d0
 move.w  d6,d1
 move.w  d7,d2
 jsr	fer3c::SpriteInit
\skip:
 move.W d6,d0
 move.w d7,d1
 move.w #FLY,Dessin(a5)

; Up ?
Up0:
 btst.b #Up_Key,d4
 bne.s	\NoDown

 move.w #FLY_UP,Dessin(a5)
 sub.w  F_Speed(a5),d1
 jsr    fer3c::GetTest
 beq.s	SuiteAct2
 move.w d1,d7
 rts

; Down ?
\NoDown:
Down0:
 btst.b #Down_Key,d4
 bne.s	SuiteAct2
 move.w #FLY_DOWN,Dessin(a5)
 add.w  F_Speed(a5),d1
 jsr    fer3c::GetTest
 beq.s	SuiteAct2
 move.w d1,d7
SuiteAct2:
 rts

Grimpe:
 move.w	d6,d0
 move.w	d7,d1
 moveq	#GRIMPE,d3
 clr.w	F_Sens(a5)
Down1:
 btst.b #Down_Key,d4
 bne.s	\No_Down
 add.w  F_Speed(a5),d1
 jsr	fer3c::GetTest
 beq.s	\No_Down
 move.w d1,d7
 bra.s	Grimpe_No_Up
\No_Down:
Up1:
 btst.b #Up_Key,d4
 bne.s	\No_Up
 sub.w  F_Speed(a5),d1
 jsr    fer3c::GetTest
 beq.s	\No_Up
 move.w d1,d7
\No_Up:
Grimpe_No_Up:
 cmpi.b #255,d4
 beq.s  \No_Next
 move.w F_Phase(a5),d2
 addq.w #1,d2
 andi.w #31,d2
 move.w d2,F_Phase(a5)
 lsr.w  #3,d2
 add.w  d2,d3
\No_Next:
 move.w	d3,Dessin(a5)
 moveq	#88,d3
 bra	Accroche_Exit1



Limites:
; Test sortie Gauche/Droite
 move.w	d6,d0
 cmpi.w #4080,d0	; 32 * tailleX - TaillXFer
 bls.s	\Suitegd
 clr.w  F_Mx(a5)	; Stop X-propulsor 
 clr.w  d6		; X = 0
 tst.w	d0
 blt.s	\Suitegd
 move.w #4080,d6	; X = 4080
\Suitegd:

; Test sortie Haut/Bas
 cmpi.w	#1004,d7
 bls.s	\Suitehb
 tst.w	d7
 blt.s	\SortieHaut
 clr.b	Mort(a6)	; You die !
 bra.s	\Suitehb
\SortieHaut:
 clr.w	F_My(a5)	; Stop Up-propulsor
 clr.w	d7		; Y=0
\Suitehb:
 rts

Sprite_L_Head:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	addq.w	#1,d1		; Y = Y + 1
	jsr	fer3c::GetTest	; Can it be possible ?
	beq.s	\Escape		; No
	move.w	d1,Yj(a5)	; Yes, save the Y coordinate
\Escape:
	subq.w	#1,L_Wait(a5)
	bne.s	\Ok
	neg.w	L_Vx(a5)
	moveq	#50,d0
	bsr	random
	add.w	#60,d0
	move.w	d0,L_Wait(a5)
\Ok:	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	add.w   L_Vx(a5),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq.s	\Conti		; No, skip
	cmp.w   #4080,d0	; Border of the screen ?
	bhi.s	\Conti
	move.w  d0,Xj(a5)	; Save X
	bra.s	\Conti2
\Conti:	
	neg.w	L_Vx(a5)	; The sprite can't go here : Vx = -Vx
\Conti2:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	jsr	fer3c::TestCollision	; Sprite and Fernando ?
	bne.s	\No		; No, skip
	cmp.w	Yj(a5),d7	; Yfernando > Y ?
	blt.s	Destroy		; Yes, so we will destroy the sprite
	jsr	fer3c::Hurt	; ...
\No:	jsr	fer3c::TestExitScreen
	bne.s	Next
	move.l  LevelTestADR(a6),a0
	move.w  Adress(a5),d0
	move.b	#NUMBER,0(a0,d0.w)	; Restore NUMBER in TestTable
	move.w	Gfx(a5),d1
	move.l	LevelADR(a6),a0
	move.b	d1,0(a0,d0.w)		; Restore the sub-sprite
	moveq	#L_End,d0
	jmp	fer3c::DestroySprite
Destroy:
	moveq	#6,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init explosion 1
	move.l  SpriteADR(a6),a0	; Get the beginining of the buffer
					; fernando is the 1st sprite.
	move.w  F_Haut(a0),d0		; Get the MaxJump that Fernando can do
	move.w  d0,F_St(a0)		; Save it
	move.w  #10,F_Action(a0)	; Init Jump2
	moveq  #L_End,d0		; Get the size of the sprite
	jmp	fer3c::DestroySprite	; Quit and destroy the sprite
Next:
	moveq	#0,d2
	move.w	L_A(a5),d2
	addq.w	#1,d2
	and.w	#31,d2
	move.w	d2,L_A(a5)
	lsr.w	#4,d2
	add.w	#LITTLE_HEAD,d2
	tst.w	L_Vx(a5)
	bgt.s	\Ok
	addq.w	#2,d2
\Ok:	move.w	Xj(a5),d0	; D0 = X
	move.w	Yj(a5),d1	; D1 = Y
	bsr	PutSprite	; put the sprite
	lea	L_End(a5),a5	; Next Sprite
	rts			; Return

Sprite_Thief:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	add.w	T_Vy(a5),d1		; Y = Y + 1
	jsr	fer3c::GetTest	; Can it be possible ?
	beq.s	\CanJump		; No
	move.w	d1,Yj(a5)	; Yes, save the Y coordinate
	bra.s	\Escape
\CanJump:
	tst.w	T_Vy(a5)
	blt.s	\Escape
	moveq	#50,d0
	bsr	random
	add.w	#60,d0
	move.w	d0,T_Wait(a5)
	neg.w	T_Vy(a5)
\Escape:
	subq.w	#1,T_Wait(a5)
	bne.s	\Ok
	neg.w	T_Vy(a5)
\Ok:	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	add.w   T_Vx(a5),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq.s	\Conti		; No, skip
	cmp.w   #4080,d0	; Border of the screen ?
	bhi.s	\Conti
	move.w  d0,Xj(a5)	; Save X
	bra.s	\Conti2
\Conti:	
	neg.w	T_Vx(a5)	; The sprite can't go here : Vx = -Vx
\Conti2:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	jsr	fer3c::TestCollision	; Sprite and Fernando ?
	bne.s	\No		; No, skip
	cmp.w	Yj(a5),d7	; Yfernando > Y ?
	blt.s	DestroyT		; Yes, so we will destroy the sprite
	jsr	fer3c::Hurt	; ...
\No:	jsr	fer3c::TestExitScreen
	bne.s	NextT
	move.l  LevelTestADR(a6),a0
	move.w  Adress(a5),d0
	move.b	#NUMBER,0(a0,d0.w)	; Restore NUMBER in TestTable
	move.w	Gfx(a5),d1
	move.l	LevelADR(a6),a0
	move.b	d1,0(a0,d0.w)		; Restore the sub-sprite
	moveq	#T_End,d0
	jmp	fer3c::DestroySprite
DestroyT:
	moveq	#6,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init explosion 1
	move.l  SpriteADR(a6),a0	; Get the beginining of the buffer
					; fernando is the 1st sprite.
	move.w  F_Haut(a0),d0		; Get the MaxJump that Fernando can do
	move.w  d0,F_St(a0)		; Save it
	move.w  #10,F_Action(a0)	; Init Jump2
	moveq	#T_End,d0		; Get the size of the sprite
	jmp	fer3c::DestroySprite	; Quit and destroy the sprite
NextT:	moveq	#0,d2
	move.w	T_A(a5),d2
	addq.w	#1,d2
	and.w	#63,d2
	move.w	d2,T_A(a5)
	lsr.w	#4,d2
	add.w	#THIEF,d2

	move.w	Xj(a5),d0	; D0 = X
	move.w	Yj(a5),d1	; D1 = Y
	bsr	PutSprite	; put the sprite
	lea	T_End(a5),a5	; Next Sprite
	rts			; Return

Sprite_Missile:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	move.w	Gfx(a5),d3
	subq.w	#3,d3
	lsl.w	#2,d3
	add.w	(Missile_Table+2)(PC,d3.w),d1		; Y = Y + 1
	add.w   (Missile_Table)(PC,d3.w),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq.s	DestroyMissile		; No
\Ok:
	move.w	d1,Yj(a5)
	move.w  d0,Xj(a5)	; Save X

	jsr	fer3c::TestCollision	; Sprite and Fernando ?
	bne.s	\No		; No, skip
	jsr	fer3c::Hurt	; ...
\No:	
	jsr	fer3c::TestExitScreen
	bne.s	NextM
DestroyMissile:
	move.w	d1,d2		; Y
	move.w	d0,d1		; X
	moveq	#INIT_ADDON,d0	; Add-On sprite
	move.l	LevelADR(a6),a0	; Get the adress of the table of gfx
	move.b	#7,(a0)		; point sprite
	clr.w	d3		; Adress : we change the adress 0
				; WARNING : Do not work with multi plan.
	jsr	fer3c::SpriteInit	; Init the sprite
	moveq	#M_End,d0
	jmp	fer3c::DestroySprite
NextM:
	moveq	#0,d2
	move.w	Gfx(a5),d2
	add.w	#(M_UP-3),d2
	bsr	PutSprite	; put the sprite
	lea	M_End(a5),a5	; Next Sprite
	rts			; Return

Missile_Table:
	dc.w	0,-2
	dc.w	-2,0
	dc.w	0,2
	dc.w	2,0
	
Sprite_Point:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	add.w	P_Vy(a5),d1		; Y = Y + 1
	add.w   P_Vx(a5),d0	; X = X + Aux_Vx
	move.w	d1,Yj(a5)	; Save y
	move.w  d0,Xj(a5)	; Save X

	jsr	fer3c::TestExitScreen
	bne.s	NextP
	moveq	#P_End,d0
	jmp	fer3c::DestroySprite
NextP:
	moveq	#EXP,d2
	bsr	PutSprite	; put the sprite
	lea	P_End(a5),a5	; Next Sprite
	rts			; Return

Sprite_Hedg:
	; Fire ?
	subq.w	#1,H_Fire(a5)
	bne.s	\NoFire
	move.w	Xj(a5),d1	; X
	move.w	Yj(a5),d2	; Y
	move.w	d1,d0
	sub.w	d6,d0
	bsr	Signe
	move.w	d0,d4		; Vx
	move.w	d2,d0
	sub.w	d7,d0
	bsr	Signe
	move.w	d0,d4		;Vy
	moveq	#4,d0		; Sprite laser
	jsr	fer3c::SpriteInit
	moveq	#127,d0
	bsr	random
	move.w	d0,H_Fire(a5)
\NoFire:
	; Gestion Y
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1

	move.w	H_Act(a5),d2
	beq.s	H_Fall
	cmp.w	#1,d2
	beq.s	H_Jump
H_Walk:
	move.w  H_A(a5),d2
	addq.w  #1,d2
	andi.w  #31,d2
	move.w  d2,H_A(a5)
	andi.w  #24,d2
	lsr.w   #2,d2
	add.w	#HEDG,d2
	move.w	d2,Dessin(a5)
	
	subq.w	#1,H_WAct(a5)
	beq.s	NewJump

	addq.w	#2,d1
	jsr	fer3c::GetTest
	beq.s	GestX
NewFall:
	clr.w	H_Act(a5)
H_Fall:
	move.w	#HEDG_DOWN,Dessin(a5)
	addq.w	#2,d1
	jsr	fer3c::GetTest
	beq.s	NewWalk
	move.w	d1,Yj(a5)
	bra.s	GestX
NewWalk:
	MOVE.w	d0,-(a7)
	moveq	#100,d0
	bsr	random
	add.w	#10,d0
	move.w	d0,H_WAct(a5)
	move.w	#2,H_Act(a5)
	MOVE.w	(a7)+,d0
	bra.s	H_Walk

NewJump:
	MOVE.w	d0,-(a7)
	moveq	#50,d0
	bsr	random
	add.w	#10,d0
	move.w	d0,H_WAct(a5)
	move.w	#1,H_Act(a5)
	MOVE.w	(a7)+,d0
H_Jump:
	move.w	#HEDG_UP,Dessin(a5)

	subq.w	#1,H_WAct(a5)
	beq.s	NewFall

	subq.w	#2,d1
	jsr	fer3c::GetTest
	beq.s	NewFall
	move.w	d1,Yj(a5)
	bra	GestX


	; Gestion X
GestX:
	subq.w	#1,H_Wait(a5)
	bne.s	\Ok
	neg.w	H_Vx(a5)
	moveq	#50,d0
	bsr	random
	add.w	#60,d0
	move.w	d0,H_Wait(a5)
\Ok:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	add.w   H_Vx(a5),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq.s	\Conti		; No, skip
	cmp.w   #4080,d0	; Border of the screen ?
	bhi.s	\Conti
	move.w  d0,Xj(a5)	; Save X
	bra.s	\Conti2
\Conti:	
	neg.w	H_Vx(a5)	; The sprite can't go here : Vx = -Vx
\Conti2:

	; Collision avec BOB ?
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	jsr	fer3c::TestCollision	; Sprite and Fernando ?
	bne.s	\No		; No, skip
	cmp.w	Yj(a5),d7	; Yfernando > Y ?
	blt.s	DestroyH		; Yes, so we will destroy the sprite
	jsr	fer3c::Hurt	; ...
\No:	
	jsr	fer3c::TestExitScreen
	bne.s	NextH
	move.l  LevelTestADR(a6),a0
	move.w  Adress(a5),d0
	move.b	#NUMBER,0(a0,d0.w)	; Restore NUMBER in TestTable
	move.w	Gfx(a5),d1
	move.l	LevelADR(a6),a0
	move.b	d1,0(a0,d0.w)		; Restore the sub-sprite
	moveq	#H_End,d0
	jmp	fer3c::DestroySprite
DestroyH:
	move.w	Time(a6),d2
	andi.w	#3,d2
	bne.s	\No2Explosion

	; 2nd Explosion
	moveq	#10,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init explosion 1

\No2Explosion:
	; Jump Bob
	move.l  SpriteADR(a6),a0	; Get the beginining of the buffer
					; fernando is the 1st sprite.
	move.w  F_Haut(a0),d0		; Get the MaxJump that Fernando can do
	move.w  d0,F_St(a0)		; Save it
	move.w  #10,F_Action(a0)	; Init Jump2

	; Fire
	move.w	#50,H_Fire(a5)

	; Test force
	subq.w	#1,H_Invu(a5)
	bne.s	NextH

	; 1st Explosion
	moveq	#6,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init explosion 1
	; Kill the sprite
	moveq  #H_End,d0		; Get the size of the sprite
	jmp	fer3c::DestroySprite	; Quit and destroy the sprite
NextH:
	moveq	#0,d2
	move.w	Dessin(a5),d2
	tst.w	H_Vx(a5)
	bgt.s	\Ok
	addq.w	#1,d2
\Ok:
	move.w	Xj(a5),d0	; D0 = X
	move.w	Yj(a5),d1	; D1 = Y
	bsr.s	PutSprite	; put the sprite
	lea	H_End(a5),a5	; Next Sprite
	rts			; Return









PutSprite:
 lsl.w	#5,d2		; 32 * D2 (A Gfx is 32 bytes long)
 lea	Graphic(PC),a0
 adda.w	d2,a0		; A0 = Adress of the gfx of the sprite
 jmp	fer3c::PutSprite

; Entry d0, return -1 if d0>0, 1 if d0<0 and 0 if d0=0
Signe:
	tst.w	d0
	blt.s	\E1
	beq.s	\E0
	moveq	#-1,d0
\E0	rts
\E1	moveq	#1,d0
	rts

Lecture:
 movem.l d0-d1,-(a7)
 move.l LevelTestADR(a6),a0
 lsr.w  #5,d0
 and.w	#(-(32-1)-1),d1	; Taille niveau X = 128 = 2^7
 lsl.w	#(7-5),d1
 add.w  d0,d1
 move.b 0(a0,d1.w),d2
 movem.l (a7)+,d0-d1
 rts

random:
	move.l	d1,-(sp)
	move.w	rand_seed(pc),d1
	mulu.w	#31421,d1
	add.w	#6927,d1
	mulu.w	d1,d0
	move.w	d1,rand_seed
	clr.w	d0
	swap	d0
	move.l	(sp)+,d1
	rts

rand_seed:
	dc.w	4571

Graphic:	INCBIN	"bob.s16"
		INCBIN	"EnmBob.s16"

; You don't need _main, _comment, end because it will be added to the world
; thanks to MkWorld. (This file is an include file).
